#ifdef ZDOOM_GL

#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_struct.h"
#include "gl_mem.h"
#include "gl_priv.h"
#include "doomdef.h"
#include "r_local.h"
#include "p_spec.h"

#include "gi.h"

#pragma optimize( "", off )

#include "d_main.h"
#include "v_video.h"
extern	DCanvas *screen;
#define SCREENWIDTH screen->width
#define SCREENHEIGHT screen->height

GLboolean g_bInitFonts=true;

// DOOM_GL
#include "hu_stuff.h"
#define SHORT (short)
#define LONG (long)
extern patch_t*		hu_font[HU_FONTSIZE];
extern int		numflats;

extern GLboolean g_b3Dfx;

extern int iNbGLTextures;
extern GLuint *texobjs;
extern byte *p_bPalette;
extern int	iNbGLSprites;
extern int iMaxSizeBeforeReduction;

extern int FontABaseLump,FontBBaseLump;
extern GLuint *FontAobjs,*FontBobjs;

extern int numpatches;
extern GLboolean g_bPaletteTexture;
extern int (WINAPI *glColorTableEXT)(GLenum enum1,GLenum enum2,GLsizei size,GLenum enum3,GLenum enum4,const GLvoid *data);

GLTexture *p_stGLFontA=NULL;
int	iNbGLFontA;
GLTexArray *p_stGLFontAArray;
GLMapSprite *p_stMapFontA=NULL;
short *FontAtopoffset,*FontAoffset;

/*GLTexture *p_stGLFontB;
int	iNbGLFontB;
GLMapSprite *p_stMapFontB;*/
GLTexArray *p_stGLFontBArray;
short *FontBtopoffset,*FontBoffset;

int numFontAlumps,numFontBlumps;

#define NB_PATCHS	230
GLTexArray *p_stGLPatchArray;
short *Patchtopoffset,*Patchoffset;
int iPatchLump[NB_PATCHS];
char a_szPatchName[NB_PATCHS][9]=
{	// Menus
	"M_PAUSE",
	"M_LOADG",
	"M_LSLEFT",
	"M_LSCNTR",
	"M_LSRGHT",
	"M_SAVEG",
	"M_SVOL",
	"M_DOOM",
	"M_NEWG",
	"M_EPISOD",
	"M_OPTTTL",
	"M_GDHIGH",
	"M_GDLOW",
	"M_MSGOFF",
	"M_MSGON",
	"M_THERML",
	"M_THERMM",
	"M_THERMR",
	"M_THERMO",
	"M_CELL1",
	"M_CELL2",
	"M_NGAME",
	"M_OPTION",
	"M_QUITG",
	"M_EPI1",
	"M_EPI2",
	"M_EPI3",
	"M_EPI4",
    "M_JKILL",
    "M_ROUGH",
    "M_HURT",
    "M_ULTRA",
    "M_NMARE",
    "M_ENDGAM",
    "M_MESSG",
    "M_DETAIL",
    "M_SCRNSZ",
    "M_MSENS",
    "M_SVOL",
    "M_SFXVOL",
    "M_MUSVOL",
	"M_SKULL1",
	"M_SKULL2",
	"M_RDTHIS",		// not doom2
	// STATUS_BAR
	"STBAR",
	"STTNUM0",
	"STTNUM1",
	"STTNUM2",
	"STTNUM3",
	"STTNUM4",
	"STTNUM5",
	"STTNUM6",
	"STTNUM7",
	"STTNUM8",
	"STTNUM9",
	"STYSNUM0",
	"STYSNUM1",
	"STYSNUM2",
	"STYSNUM3",
	"STYSNUM4",
	"STYSNUM5",
	"STYSNUM6",
	"STYSNUM7",
	"STYSNUM8",
	"STYSNUM9",
	"STTPRCNT",
	"STKEYS0",
	"STKEYS1",
	"STKEYS2",
	"STKEYS3",
	"STKEYS4",
	"STKEYS5",
	"STARMS",
	"STGNUM0",
	"STGNUM1",
	"STGNUM2",
	"STGNUM3",
	"STGNUM4",
	"STGNUM5",
	"STFB0",
	"STFB1",
	"STFB2",
	"STFB3",
	"STFST00",
	"STFST01",
	"STFST02",
	"STFST10",
	"STFST11",
	"STFST12",
	"STFST20",
	"STFST21",
	"STFST22",
	"STFST30",
	"STFST31",
	"STFST32",
	"STFST40",
	"STFST41",
	"STFST42",
	"STFTR00",
	"STFTR10",
	"STFTR20",
	"STFTR30",
	"STFTR40",
	"STFTL00",
	"STFTL10",
	"STFTL20",
	"STFTL30",
	"STFTL40",
	"STFOUCH0",
	"STFOUCH1",
	"STFOUCH2",
	"STFOUCH3",
	"STFOUCH4",
	"STFEVL0",
	"STFEVL1",
	"STFEVL2",
	"STFEVL3",
	"STFEVL4",
	"STFKILL0",
	"STFKILL1",
	"STFKILL2",
	"STFKILL3",
	"STFKILL4",
	"STFGOD0",
	"STFDEAD0",
	"STTMINUS",
	// Intermissions
	"WIURH0",
	"WIURH1",
	"WISPLAT",
	"WIMINUS",
	"WINUM0",
	"WINUM1",
	"WINUM2",
	"WINUM3",
	"WINUM4",
	"WINUM5",
	"WINUM6",
	"WINUM7",
	"WINUM8",
	"WINUM9",
	"WIPCNT",
	"WIF",
	"WIENTER",
	"WIOSTK",
	"WIOSTS",
	"WISCRT2",
	"WIOBJ",
	"WIOSTI",
	"WIFRGS",
	"WICOLON",
	"WITIME",
	"WISUCKS",
	"WIPAR",
	"WIKILRS",
	"WIVCTMS",
	"WIMSTT",
	"STFST01",
	"STFDEAD0",
	"WIBP0",
	"WIBP1",
	"WIBP2",
	"WIBP3",
	// Doom I:
	"WILV00",
	"WILV01",
	"WILV02",
	"WILV03",
	"WILV04",
	"WILV05",
	"WILV06",
	"WILV07",
	"WILV08",
	"WILV10",
	"WILV11",
	"WILV12",
	"WILV13",
	"WILV14",
	"WILV15",
	"WILV16",
	"WILV17",
	"WILV18",
	"WILV20",
	"WILV21",
	"WILV22",
	"WILV23",
	"WILV24",
	"WILV25",
	"WILV26",
	"WILV27",
	"WILV28",
	"WILV30",
	"WILV31",
	"WILV32",
	"WILV33",
	"WILV34",
	"WILV35",
	"WILV36",
	"WILV37",
	"WILV38",
	// Doom II:
	"CWILV00",
	"CWILV01",
	"CWILV02",
	"CWILV03",
	"CWILV04",
	"CWILV05",
	"CWILV06",
	"CWILV07",
	"CWILV08",
	"CWILV09",
	"CWILV10",
	"CWILV11",
	"CWILV12",
	"CWILV13",
	"CWILV14",
	"CWILV15",
	"CWILV16",
	"CWILV17",
	"CWILV18",
	"CWILV19",
	"CWILV20",
	"CWILV21",
	"CWILV22",
	"CWILV23",
	"CWILV24",
	"CWILV25",
	"CWILV26",
	"CWILV27",
	"CWILV28",
	"CWILV29",
	"CWILV30",
	"CWILV31"
};

#define NB_SCREENS 11
char a_szScreenNames[NB_SCREENS][9]=
{	
	// V_DrawPatch
	"TITLEPIC",
	"HELP",
	"HELP1",
	"HELP2",
	"CREDIT",
	"INTERPIC",
	"WIMAP0",
	"WIMAP1",
	"WIMAP2",
	"VICTORY2",
	"ENDPIC"
	// V_DrawRawScreen
};

#define MNU_X(x)		(int)((float)(x)*SCREENWIDTH/320.0f)
#define MNU_Y(y)		(int)((float)(y)*SCREENHEIGHT/200.0f)
extern float fScaleSprite;

// ZDGL
extern GLboolean g_bDynamicAlloc;
int iNbPatchs=0;
int g_iGLConChars,iSubConChars;
int GL_iRegisterPatch(patch_t *patch,int *iSubTex)
{
  int iPrevMax;
  float fPrevScale;
  int iTexIndex;
  int iPrevNbGLFontA;
  GLboolean bDynAlloc;

	bDynAlloc=g_bDynamicAlloc;
	g_bDynamicAlloc=TRUE;
	/*SPRITE_WIDTH=128;
	SPRITE_HEIGHT=128;*/
	SPRITE_WIDTH=256;
	SPRITE_HEIGHT=256;
	if (!p_stGLPatchArray)
	{	p_stGLPatchArray=(GLTexArray *)glMalloc(sizeof(GLTexArray));
		Patchtopoffset=(short *)glMalloc(sizeof(short));
		Patchoffset=(short *)glMalloc(sizeof(short));
		p_stGLFontA=(GLTexture *)glMalloc(sizeof(GLTexture));
		p_stMapFontA=(GLMapSprite *)glMalloc(sizeof(GLMapSprite));
		p_bPalette=(unsigned char *)W_CacheLumpName("PLAYPAL", PU_STATIC);
	}
	else
	{
		p_stGLPatchArray=(GLTexArray *)glRealloc(p_stGLPatchArray,(iNbPatchs+1)*sizeof(GLTexArray));
		Patchtopoffset=(short *)glRealloc(Patchtopoffset,(iNbPatchs+1)*sizeof(short));
		Patchoffset=(short *)glRealloc(Patchtopoffset,(iNbPatchs+1)*sizeof(short));
	}

	p_stGLPatchArray[iNbPatchs].iTexID=-1;

	fPrevScale=fScaleSprite;
	iPrevMax=iMaxSizeBeforeReduction;
	iMaxSizeBeforeReduction=0x7fffffff;

	/*if (patch->width>128)
	{	SPRITE_WIDTH=256;
		SPRITE_HEIGHT=256;
	}*/
	
	if ((patch->width>256)&&g_b3Dfx)
	{	iMaxSizeBeforeReduction=patch->width*patch->height-1;
		fScaleSprite=256.0f/(float)patch->width;
	}

	iPrevNbGLFontA=iNbGLSprites;

	iTexIndex=fn_vRegisterSpriteCompressed(&p_stGLFontA,&p_stMapFontA,&p_stGLPatchArray,iNbPatchs,patch);
	if (patch->width>256)
		iMaxSizeBeforeReduction=0x7fffffff;

	iMaxSizeBeforeReduction=iPrevMax;
	fScaleSprite=fPrevScale;

	iNbGLFontA=iNbGLSprites;

	iTexIndex=p_stGLPatchArray[iNbPatchs].iGLTexIndex;
	*iSubTex=p_stGLPatchArray[iNbPatchs].iUVIndex;
	iNbPatchs++;

	// ------------------------------------------

	if (iNbGLFontA!=iPrevNbGLFontA)
	{	FontAobjs=(GLuint *)glRealloc(FontAobjs,iNbGLFontA*sizeof(GLuint));
#ifndef MINIGL
		glGenTextures(1,FontAobjs+iNbGLFontA-1);
#else
		FontAobjs[iNbGLFontA-1]=40000+iNbGLFontA-1;
#endif
	}

	glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	//if (patch->width<256)
	{	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	}
	/*else
	{
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR);
		glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR);
	}*/
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

	glTexImage2D(GL_TEXTURE_2D, 0, 4, p_stGLFontA[iTexIndex].iWidth, p_stGLFontA[iTexIndex].iHeight, 0, GL_RGBA, GL_UNSIGNED_BYTE, p_stGLFontA[iTexIndex].p_bRGBBuffer);
	
	//--------------------------------------------

	g_bDynamicAlloc=bDynAlloc;

	return iTexIndex;
}

void GL_vRegisterConChars(patch_t *chars)
{ 
  char cMemMode;
  int iNbSpr;
  GLboolean bInitFonts;

	cMemMode=fn_cGetMemoryMode();
	fn_vSetMemoryMode(FIX);
	iNbSpr=iNbGLSprites;
	iNbGLSprites=iNbGLFontA;
	bInitFonts=g_bInitFonts;
	g_bInitFonts=true;

	g_iGLConChars=GL_iRegisterPatch(chars,&iSubConChars);
//	fn_vSaveRAW("merde.raw",p_stGLFontA[g_iGLConChars].p_bRGBBuffer,128,128);

	fn_vSetMemoryMode(cMemMode);
	iNbGLSprites=iNbSpr;
	g_bInitFonts=bInitFonts;
}


patch_t *GL_CacheLumpNum (int lump, int tag)
{ patch_t *patch;
  int iSubTex;
  int iGLIndex;
  char cMemMode;
  int iNbSpr;
  GLboolean bInitFonts;

	if (lumpcache[lump])
		return (patch_t *)lumpcache[lump];
	cMemMode=fn_cGetMemoryMode();
	fn_vSetMemoryMode(FIX);
	iNbSpr=iNbGLSprites;
	iNbGLSprites=iNbGLFontA;
	bInitFonts=g_bInitFonts;
	g_bInitFonts=true;
	
	patch=(patch_t *)W_CacheLumpNum(lump,tag);
	iGLIndex=GL_iRegisterPatch(patch,&iSubTex);
	// the textures are now "GLised", so the column informations are useless...
	patch->columnofs[0]=-1;		// -1 means the texture is now GLised
	patch->columnofs[1]=iGLIndex;
	patch->columnofs[2]=iSubTex;

	fn_vSetMemoryMode(cMemMode);
	iNbGLSprites=iNbSpr;
	g_bInitFonts=bInitFonts;

	return patch;
}

void GL_DrawPatch(DCanvas::EWrapperCode drawer, const patch_t *patch, int x, int y)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight;

		if (patch->columnofs[0]!=-1)
			return;
		
		y -= SHORT(patch->topoffset);
		x -= SHORT(patch->leftoffset);

		iTexIndex=patch->columnofs[1];
		iSubTex=patch->columnofs[2];
		fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
		fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
		fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
		fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
		iWidth=patch->width;
		iHeight=patch->height;
		if ((iWidth==320)&&(iHeight==200))
		{	iWidth=SCREENWIDTH;
			iHeight=SCREENHEIGHT;
		}

		glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);
		glColor3f(1.0f,1.0f,1.0f);

		glBegin(GL_QUADS);
			// vertex2f for 3dfx minigl...
			glTexCoord2f(fU1, fV1); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y) );
			glTexCoord2f(fU1, fV2); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y-iHeight) );
			glTexCoord2f(fU2, fV2); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y-iHeight) );
			glTexCoord2f(fU2, fV1); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y) );
		glEnd();
}

void GL_DrawSPatch(DCanvas::EWrapperCode drawer, const patch_t *patch, int x, int y, int destwidth, int destheight)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight;
  int xmul,ymul;

		if (patch->columnofs[0]!=-1)
			return;
		
		if (destwidth == SHORT(patch->width) && destheight == SHORT(patch->height))
		{
			GL_DrawPatch (drawer, patch, x, y);
			return;
		}

		/*if (destwidth == width && destheight == height &&
			SHORT(patch->width) == 320 && SHORT(patch->height) == 200
			&& drawer == EWrapper_Normal)
		{
			// Special case: Drawing a full-screen patch, so use
			// F_DrawPatchCol in f_finale.c, since it's faster.
			for (w = 0; w < 320; w++)
				F_DrawPatchCol (w, patch, w, this);
			return;
		}*/

		/*xinc = (SHORT(patch->width) << 16) / destwidth;
		yinc = (SHORT(patch->height) << 16) / destheight;*/
		xmul = (destwidth << 16) / SHORT(patch->width);
		ymul = (destheight << 16) / SHORT(patch->height);

		y -= (SHORT(patch->topoffset) * ymul) >> 16;
		x -= (SHORT(patch->leftoffset) * xmul) >> 16;

		iTexIndex=patch->columnofs[1];
		iSubTex=patch->columnofs[2];
		fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
		fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
		fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
		fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
		iWidth=destwidth;
		iHeight=destheight;

		glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);
		glColor3f(1.0f,1.0f,1.0f);

		glBegin(GL_QUADS);
			// vertex2f for 3dfx minigl...
			glTexCoord2f(fU1, fV1); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y) );
			glTexCoord2f(fU1, fV2); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y-iHeight) );
			glTexCoord2f(fU2, fV2); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y-iHeight) );
			glTexCoord2f(fU2, fV1); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y) );
		glEnd();
}

void GL_vPrintStr (int x, int y, const char *s, int count)
{ int tmp;
  float fU1,fV1,fU2,fV2;
  unsigned char c;

	glBindTexture(GL_TEXTURE_2D, FontAobjs[g_iGLConChars]);
	glColor3f(1.0f,1.0f,1.0f);

	while (count && x <= (SCREENWIDTH - 8))
	{
		c=*s;
		tmp=(int)c/16;
		fU1=(float)((int)c-tmp*16)*8.0f;
		fV1=8.0f*tmp;
		fU2=fU1+8.0f;
		fV2=fV1+8.0f;
		/*fU1/=128.0f;
		fV1/=128.0f;
		fU2/=128.0f;
		fV2/=128.0f;*/
		fU1/=256.0f;
		fV1/=256.0f;
		fU2/=256.0f;
		fV2/=256.0f;
		fU1+=(float)p_stGLFontA[g_iGLConChars].a_stSubTex[iSubConChars].iU/(float)p_stGLFontA[g_iGLConChars].iWidth;
		fV1+=(float)p_stGLFontA[g_iGLConChars].a_stSubTex[iSubConChars].iV/(float)p_stGLFontA[g_iGLConChars].iHeight;
		fU2+=(float)p_stGLFontA[g_iGLConChars].a_stSubTex[iSubConChars].iU/(float)p_stGLFontA[g_iGLConChars].iWidth;
		fV2+=(float)p_stGLFontA[g_iGLConChars].a_stSubTex[iSubConChars].iV/(float)p_stGLFontA[g_iGLConChars].iHeight;
		
		glBegin(GL_QUADS);
			glTexCoord2f(fU1, fV1); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y) );
			glTexCoord2f(fU1, fV2); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y-8) );
			glTexCoord2f(fU2, fV2); glVertex2f( (float)(x+8), (float)(SCREENHEIGHT-1-y-8) );
			glTexCoord2f(fU2, fV1); glVertex2f( (float)(x+8), (float)(SCREENHEIGHT-1-y) );
		glEnd();
		x+=8;
		s++;
		count--;
	}
}

patch_t *g_stConBackG;
extern gameinfo_t gameinfo;
extern DCanvas *conback;

void GL_vDrawConBackG(int width,int height)
{ int iTexIndex,iSubTex;
  float fU1,fU2,fV1,fV2;

	if (!g_stConBackG)
	{	conback->DrawBlock(0,0,320,200,NULL);
		return;
	}

	if (g_stConBackG->columnofs[0]!=-1)
	{	//return;
	  int num;
		num = W_CheckNumForName ("CONBACK");
		if (num == -1)
		{
			num = W_GetNumForName (gameinfo.titlePage);
		}

		g_stConBackG = (patch_t *)GL_CacheLumpNum (num, PU_CACHE);
	}

	iTexIndex=g_stConBackG->columnofs[1];
	iSubTex=g_stConBackG->columnofs[2];
	fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
	fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
	fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
	fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
	fV1+=(float)((SCREENHEIGHT-height)*p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/((float)SCREENHEIGHT*(float)p_stGLFontA[iTexIndex].iHeight);

	glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

	glColor4f(0.4f,0.4f,0.4f,0.8f);
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);

	glBegin(GL_QUADS);
		glTexCoord2f(fU1, fV1); glVertex2f( 0.0f, (float)(SCREENHEIGHT-1) );
		glTexCoord2f(fU1, fV2); glVertex2f( 0.0f, (float)(SCREENHEIGHT-1-height) );
		glTexCoord2f(fU2, fV2); glVertex2f( (float)width, (float)(SCREENHEIGHT-1-height) );
		glTexCoord2f(fU2, fV1); glVertex2f( (float)width, (float)(SCREENHEIGHT-1) );
	glEnd();	

	glDisable(GL_BLEND);
}

unsigned char *p_bRGBTitle1[NB_SCREENS],*p_bRGBTitle2[NB_SCREENS];
int iGlObjTITLE=0;
void GL_DrawBlock(int x, int y, int _width, int _height,DCanvas *page)
{	int i=page->bits;

	glEnable(GL_TEXTURE_2D);
	glColor3f(1.0f,1.0f,1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glBindTexture(GL_TEXTURE_2D,i);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);				glVertex2f(0,(float)SCREENHEIGHT);
		glTexCoord2f(1,0);				glVertex2f(0.8f*SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0.78125f);		glVertex2f(0.8f*SCREENWIDTH,0);
		glTexCoord2f(0,0.78125f);		glVertex2f(0,0);
	glEnd();
	glBindTexture(GL_TEXTURE_2D,i+1);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);				glVertex2f(0.8f*SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0);				glVertex2f((float)SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0.78125f);		glVertex2f((float)SCREENWIDTH,0);
		glTexCoord2f(0,0.78125f);		glVertex2f(0.8f*SCREENWIDTH,0);
	glEnd();
}

GLvoid GLRegisterScreen(char *pagename,DCanvas *page)	// 2 textures for one 320x200 screen because of the 3Dfx limitations (256x256)
{ byte *patch;
  int x,y;
  GLuint iTex,i=iGlObjTITLE;
	
	patch=(byte *)W_CacheLumpName(pagename,PU_CACHE);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	p_bRGBTitle1[i]=(unsigned char *)glMalloc(256*256);
		for (x=0;x<256;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][x+y*256]=patch[x+y*320];
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)glMalloc(64*256);
		for (x=256;x<320;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][x-256+y*64]=patch[x+y*320];
			}
		}
	}
	else
#endif
	{
		p_bRGBTitle1[i]=(unsigned char *)glMalloc(256*256*3);
		for (x=0;x<256;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][3*(x+y*256)]=p_bPalette[3*patch[x+y*320]];
				p_bRGBTitle1[i][3*(x+y*256)+1]=p_bPalette[3*patch[x+y*320]+1];
				p_bRGBTitle1[i][3*(x+y*256)+2]=p_bPalette[3*patch[x+y*320]+2];
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)glMalloc(64*256*3);
		for (x=256;x<320;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][3*(x-256+y*64)]=p_bPalette[3*patch[x+y*320]];
				p_bRGBTitle2[i][3*(x-256+y*64)+1]=p_bPalette[3*patch[x+y*320]+1];
				p_bRGBTitle2[i][3*(x-256+y*64)+2]=p_bPalette[3*patch[x+y*320]+2];
			}
		}
	}

	//iGlObjTITLE = 10000+iNbGLFontA+1;
	glGenTextures(1,&iTex);
	glBindTexture(GL_TEXTURE_2D, iTex);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 256, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);

	glBindTexture(GL_TEXTURE_2D, iTex+1);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 64, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 64, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);

	page->bits=iTex;
	iGlObjTITLE++;
}
// End ZDGL
/*
void fn_vRegisterPatchs()
{ patch_t *patch;
  int i;
  int iPrevMax;
  float fPrevScale;

	fPrevScale=fScaleSprite;
	iPrevMax=iMaxSizeBeforeReduction;
	iMaxSizeBeforeReduction=0x7fffffff;

	p_stGLPatchArray=(GLTexArray *)glMalloc(NB_PATCHS*sizeof(GLTexArray));

	for (i=0;i<NB_PATCHS;i++)
		p_stGLPatchArray[i].iTexID=-1;

	Patchtopoffset=(short *)glMalloc(NB_PATCHS*sizeof(short));
	Patchoffset=(short *)glMalloc(NB_PATCHS*sizeof(short));
	for (i=0;i<NB_PATCHS;i++)
	{	

		if (W_CheckNumForName(a_szPatchName[i])==-1)		// DOOM_GL: shareware...
			continue;
		
		iPatchLump[i]=W_GetNumForName(a_szPatchName[i]);
		patch = (struct patch_s *)W_CacheLumpNum(iPatchLump[i], PU_CACHE);
		Patchtopoffset[i]=patch->topoffset;
		Patchoffset[i]=patch->leftoffset;
		
		if (g_b3Dfx)
		{	if ((!strcmp(a_szPatchName[i],"STBAR")))
			{	iMaxSizeBeforeReduction=2;
				fScaleSprite=0.8f;
			}
			else
				iMaxSizeBeforeReduction=65536;
		}
		if (!strcmp(a_szPatchName[i],"M_EPI1"))
		{	iMaxSizeBeforeReduction=2;
			fScaleSprite=256.0f/263.0f;
		}

		if (patch->width>256)
			iMaxSizeBeforeReduction=patch->width*patch->height-1;
		fn_vRegisterSpriteCompressed(&p_stGLFontA,&p_stMapFontA,&p_stGLPatchArray,i,patch);
		if (patch->width>256)
			iMaxSizeBeforeReduction=0x7fffffff;
	}
	iNbGLFontA=iNbGLSprites;
//	fn_vSaveRAW("bar0.raw",p_stGLFontA[0].p_bRGBBuffer,128,128);
//	fn_vSaveRAW("bar1.raw",p_stGLFontA[1].p_bRGBBuffer,256,128);
//	fn_vSaveRAW("bar2.raw",p_stGLFontA[2].p_bRGBBuffer,256,128);

	iMaxSizeBeforeReduction=iPrevMax;
	fScaleSprite=fPrevScale;
}

int GL_GetNumForName(char *szName)
{ int i;

	for (i=0;i<NB_PATCHS;i++)
		if (!stricmp(szName,a_szPatchName[i]))
			return i;
	return -1;
}

void GL_DrawCompressedPatch(int x, int y, int iWidth, int iHeight,int iLump)
// For 3Dfx (Max texture size is 256x256)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,i;

		if (iLump==-1)
			return;	// Patch not registered
		i=iLump;
		{
			x=MNU_X(x);
			y=MNU_Y(y);

			y -= SHORT(MNU_Y(Patchtopoffset[i]));
			x -= SHORT(MNU_X(Patchoffset[i]));

			iTexIndex=p_stGLPatchArray[i].iGLTexIndex;
			iSubTex=p_stGLPatchArray[i].iUVIndex;
			fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
			fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
			fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
			fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
			iWidth=MNU_X(iWidth);
			iHeight=MNU_Y(iHeight);


			glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

			glBegin(GL_QUADS);
				// vertex2f for 3dfx minigl...
				glTexCoord2f(fU1, fV1); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y) );
				glTexCoord2f(fU1, fV2); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y-iHeight) );
				glTexCoord2f(fU2, fV2); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y-iHeight) );
				glTexCoord2f(fU2, fV1); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y) );
			glEnd();
		}
}

int GL_iPatchWidth(int lump)
{ int iTexIndex=p_stGLPatchArray[lump].iGLTexIndex;
  int iSubTex=p_stGLPatchArray[lump].iUVIndex;

	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth;
}

int GL_iPatchHeight(int lump)
{ int iTexIndex=p_stGLPatchArray[lump].iGLTexIndex;
  int iSubTex=p_stGLPatchArray[lump].iUVIndex;

	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight;
}

void oldGL_DrawPatch(int x, int y, int iLump)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight,i;

		if (iLump==-1)
			return;	// Patch not registered
		i=iLump;
		{
			x=MNU_X(x);
			y=MNU_Y(y);

			y -= SHORT(MNU_Y(Patchtopoffset[i]));
			x -= SHORT(MNU_X(Patchoffset[i]));

			iTexIndex=p_stGLPatchArray[i].iGLTexIndex;
			iSubTex=p_stGLPatchArray[i].iUVIndex;
			fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
			fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
			fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
			fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
			iWidth=MNU_X(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth);
			iHeight=MNU_Y(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight);

			glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

			glBegin(GL_QUADS);
				// vertex2f for 3dfx minigl...
				glTexCoord2f(fU1, fV1); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y) );
				glTexCoord2f(fU1, fV2); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y-iHeight) );
				glTexCoord2f(fU2, fV2); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y-iHeight) );
				glTexCoord2f(fU2, fV1); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y) );
			glEnd();

//			break;
		}
}

void GL_DrawShadowedPatch(int x, int y, int iLump)
{
	glColor3f(0.5f,0.5f,0.5f);
	GL_DrawShadowedPatch(x,y,iLump);
	glColor3f(1.0f,1.0f,1.0f);
}
*/
GLvoid fn_vGLInitFonts()
{ 	
	iNbGLSprites=0;

	SPRITE_WIDTH=SPRITE_HEIGHT=128;
	g_bInitFonts=false;
}

/*
int GL_DrawLetterA(int x,int y,int lump)
{ float fU1,fU2,fV1,fV2;
  int iTexIndex,iSubTex,iWidth,iHeight;

	// DOOM_GL
	x=MNU_X(x);
	y=MNU_Y(y);

	y -= SHORT(MNU_Y(FontAtopoffset[lump]));
	x -= SHORT(MNU_X(FontAoffset[lump]));

	iTexIndex=p_stGLFontAArray[lump].iGLTexIndex;
	iSubTex=p_stGLFontAArray[lump].iUVIndex;
	fU1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU/(float)p_stGLFontA[iTexIndex].iWidth;
	fU2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iU+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth)/(float)p_stGLFontA[iTexIndex].iWidth;
	fV1=(float)p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV/(float)p_stGLFontA[iTexIndex].iHeight;
	fV2=(float)(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iV+p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight)/(float)p_stGLFontA[iTexIndex].iHeight;
	iWidth=MNU_X(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth);
	iHeight=MNU_Y(p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iHeight);

	glBindTexture(GL_TEXTURE_2D, FontAobjs[iTexIndex]);

	glBegin(GL_QUADS);
		// 2f for 3dfx minigl...
		glTexCoord2f(fU1, fV1); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y) );
		glTexCoord2f(fU1, fV2); glVertex2f( (float)x, (float)(SCREENHEIGHT-1-y-iHeight) );
		glTexCoord2f(fU2, fV2); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y-iHeight) );
		glTexCoord2f(fU2, fV1); glVertex2f( (float)(x+iWidth), (float)(SCREENHEIGHT-1-y) );
	glEnd();

	//return iWidth;
	return p_stGLFontA[iTexIndex].a_stSubTex[iSubTex].iWidth;
}

*/
// For the MAP
CVAR (g_bAutoMapHack, "0", CVAR_ARCHIVE)
GLvoid GL_DrawLine(int X0, int Y0, int X1, int Y1, byte BaseColor)
{
	glDisable(GL_TEXTURE_2D);
/*	glLineWidth(2);
	glEnable(GL_LINE_SMOOTH);*/
	glColor3f((float)p_bPalette[3*BaseColor]/255.0f,(float)p_bPalette[3*BaseColor+1]/255.0f,(float)p_bPalette[3*BaseColor+2]/255.0f);
	if (!g_bAutoMapHack.value)
	{	glBegin(GL_LINES);
			glVertex2i( X0, SCREENHEIGHT-1-Y0 );
			glVertex2i( X1, SCREENHEIGHT-1-Y1 );
		glEnd();
	}
	else
	{ float dx,dy,x1,x2,x3,x4,y1,y2,y3,y4,angle;

		if( X1 != X0 )
			angle = (float)atan((float)(Y1-Y0)/(float)(X1-X0));
		else
			angle = 1.57f;
		dx = (float)sin(angle) / 2.0f;
		dy = (float)cos(angle) / 2.0f;

		x1 = X0 - dx;  y1 = Y0 + dy;
		x2 = X1 - dx;  y2 = Y1 + dy;
		x3 = X1 + dx;  y3 = Y1 - dy;
		x4 = X0 + dx;  y4 = Y0 - dy;

		glBegin( GL_TRIANGLE_FAN );
			glVertex2f( x1, (float)(SCREENHEIGHT-1-y1) );
			glVertex2f( x2, (float)(SCREENHEIGHT-1-y2) );
			glVertex2f( x3, (float)(SCREENHEIGHT-1-y3) );
			glVertex2f( x4, (float)(SCREENHEIGHT-1-y4) );
		glEnd();
	}

	glEnable(GL_TEXTURE_2D);
}
/*
GLvoid GL_DumpScreen()
{ 
	glColor3f(1.0f,1.0f,1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glRasterPos2i(0,0);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glDrawPixels(SCREENWIDTH,SCREENHEIGHT,GL_COLOR_INDEX8_EXT,GL_UNSIGNED_BYTE,screen);
	}
	else
#endif
		glDrawPixels(SCREENWIDTH,SCREENHEIGHT,GL_RGB,GL_UNSIGNED_BYTE,screen);
	glEnable(GL_TEXTURE_2D);
	glColor3f(1.0f,1.0f,1.0f);
}

GLvoid GL_RegisterPatchScreen(int i)
{ int x=0,y=0;
	int count;
	int col;
	column_t *column;
	byte *source;
	int w;
	patch_t *patch;

	if (W_CheckNumForName(a_szScreenNames[i])==-1)		// shareware...
		return;
	patch=(patch_t *)W_CacheLumpName(a_szScreenNames[i],PU_CACHE);
	w = SHORT(patch->width);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	p_bRGBTitle1[i]=(unsigned char *)glMalloc(256*256);
		for (col=0;col<256;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle1[i][col+y*256]=*source;
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)glMalloc(64*256);
		for (col=256;col<320;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle2[i][col-256+y*64]=*source;
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
		}
	}
	else
#endif
	{
		p_bRGBTitle1[i]=(unsigned char *)glMalloc(256*256*3);
		for (col=0;col<256;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle1[i][3*(col+y*256)]=p_bPalette[3**source];
					p_bRGBTitle1[i][3*(col+y*256)+1]=p_bPalette[3**source+1];
					p_bRGBTitle1[i][3*(col+y*256)+2]=p_bPalette[3**source+2];
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)glMalloc(64*256*3);
		for (col=256;col<320;col++)
		{	column = (column_t *)((byte *)patch+LONG(patch->columnofs[col]));
			y=0;
			while (column->topdelta != 0xff )
			{ 
				source = (byte *)column + 3;
				count = column->length;

				while (count--)
				{
					p_bRGBTitle2[i][3*(col-256+y*64)]=p_bPalette[3**source];
					p_bRGBTitle2[i][3*(col-256+y*64)+1]=p_bPalette[3**source+1];
					p_bRGBTitle2[i][3*(col-256+y*64)+2]=p_bPalette[3**source+2];
					source++;
					y++;
				}
				column = (column_t *)(  (byte *)column + column->length+ 4 );
			}
		}
	}

	//iGlObjTITLE = numspritelumps+numflats+numpatches+iNbGLFontA+1;
	iGlObjTITLE = numspritelumps+2000+iNbGLFontA+1;	// 2000... risque de poser problme...
	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 256, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);

	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i+1);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 64, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 64, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
}
		

GLvoid GLDrawScreen(int i)
{ 	
	glEnable(GL_TEXTURE_2D);
	glColor3f(1.0f,1.0f,1.0f);
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glBindTexture(GL_TEXTURE_2D,iGlObjTITLE+2*i);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);				glVertex2f(0,(float)SCREENHEIGHT);
		glTexCoord2f(1,0);				glVertex2f(0.8f*SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0.78125f);		glVertex2f(0.8f*SCREENWIDTH,0);
		glTexCoord2f(0,0.78125f);		glVertex2f(0,0);
	glEnd();
	glBindTexture(GL_TEXTURE_2D,iGlObjTITLE+2*i+1);
	glBegin(GL_QUADS);
		glTexCoord2f(0,0);				glVertex2f(0.8f*SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0);				glVertex2f((float)SCREENWIDTH,(float)SCREENHEIGHT);
		glTexCoord2f(1,0.78125f);		glVertex2f((float)SCREENWIDTH,0);
		glTexCoord2f(0,0.78125f);		glVertex2f(0.8f*SCREENWIDTH,0);
	glEnd();
}

GLvoid GLDrawScreenFromName(char *name)
{ int i;
	for (i=0;i<NB_SCREENS;i++)
		if (!strcmp(name,a_szScreenNames[i]))
			break;
	if (i==NB_SCREENS)
		return;

	GLDrawScreen(i);
}

GLvoid GLRegisterScreen(int i)	// 2 textures for one 320x200 screen because of the 3Dfx limitations (256x256)
{ byte *patch;
  int x,y;
	
	patch=(byte *)W_CacheLumpName(a_szScreenNames[i],PU_CACHE);
#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	p_bRGBTitle1[i]=(unsigned char *)glMalloc(256*256);
		for (x=0;x<256;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][x+y*256]=patch[x+y*320];
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)glMalloc(64*256);
		for (x=256;x<320;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][x-256+y*64]=patch[x+y*320];
			}
		}
	}
	else
#endif
	{
		p_bRGBTitle1[i]=(unsigned char *)glMalloc(256*256*3);
		for (x=0;x<256;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle1[i][3*(x+y*256)]=p_bPalette[3*patch[x+y*320]];
				p_bRGBTitle1[i][3*(x+y*256)+1]=p_bPalette[3*patch[x+y*320]+1];
				p_bRGBTitle1[i][3*(x+y*256)+2]=p_bPalette[3*patch[x+y*320]+2];
				//p_bRGBTitle1[i][4*(x+y*256)+3]=255;
			}
		}
		p_bRGBTitle2[i]=(unsigned char *)glMalloc(64*256*3);
		for (x=256;x<320;x++)
		{
			for (y=0;y<200;y++)
			{	
				p_bRGBTitle2[i][3*(x-256+y*64)]=p_bPalette[3*patch[x+y*320]];
				p_bRGBTitle2[i][3*(x-256+y*64)+1]=p_bPalette[3*patch[x+y*320]+1];
				p_bRGBTitle2[i][3*(x-256+y*64)+2]=p_bPalette[3*patch[x+y*320]+2];
				//p_bRGBTitle2[i][4*(x-256+y*64)+3]=255;
			}
		}
	}

	//iGlObjTITLE = numspritelumps+numflats+numpatches+iNbGLFontA+1;
	iGlObjTITLE = numspritelumps+2000+iNbGLFontA+1;
	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 256, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 256, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle1[i]);

	glBindTexture(GL_TEXTURE_2D, iGlObjTITLE+2*i+1);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_NEAREST);
	glTexParameterf(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_NEAREST);
//#endif
	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);

#ifdef PALETTED_TEXTURE
	if (g_bPaletteTexture)
	{	
		glColorTableEXT(GL_TEXTURE_2D,GL_RGB8,256,GL_RGB,GL_UNSIGNED_BYTE,p_bPalette);
		glTexImage2D(GL_TEXTURE_2D, 0, GL_COLOR_INDEX8_EXT, 64, 256, 0, GL_COLOR_INDEX, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
	}
	else
#endif
	glTexImage2D(GL_TEXTURE_2D, 0, 3, 64, 256, 0, GL_RGB, GL_UNSIGNED_BYTE, p_bRGBTitle2[i]);
}

GLvoid GLRegisterScreens()
{
// DOOM_GL: A VOIR
	GL_RegisterPatchScreen(0);
	GL_RegisterPatchScreen(1);
	GL_RegisterPatchScreen(2);
	GL_RegisterPatchScreen(3);
	GL_RegisterPatchScreen(4);
	// Inter missions...	
	GL_RegisterPatchScreen(6);
	if ((gamemode==commercial)||(gamemode==retail))
		GL_RegisterPatchScreen(5);
	if ((gamemode==retail)||(gamemode==registered))
	{	GL_RegisterPatchScreen(7);
		GL_RegisterPatchScreen(8);
	}
}

void GL_DrawStatBack(char *name)
{
	int x;
	int y;
	int i;

	byte *src;
	byte *dest;

	src = (unsigned char *)W_CacheLumpName (name, PU_CACHE);
	dest = screen->buffer;

	for (y=0 ; y<SCREENHEIGHT ; y++)
	{
		for (x=0 ; x<SCREENWIDTH/64 ; x++)
		{
#ifdef PALETTED_TEXTURE
			if (g_bPaletteTexture)
			{	memcpy (dest, src+((y&63)<<6), 64);
				dest += 64;
			}
			else
#endif
			for (i=0;i<64;i++)
			{	dest[3*(64*x+i+SCREENWIDTH*y)]=p_bPalette[3*src[i+((y&63)<<6)]];
				dest[3*(64*x+i+SCREENWIDTH*y)+1]=p_bPalette[3*src[i+((y&63)<<6)]+1];
				dest[3*(64*x+i+SCREENWIDTH*y)+2]=p_bPalette[3*src[i+((y&63)<<6)]+2];
			}
		}
		if (SCREENWIDTH&63)
		{
#ifdef PALETTED_TEXTURE
			if (g_bPaletteTexture)
			{	memcpy (dest, src+((y&63)<<6), SCREENWIDTH&63);
				dest += (SCREENWIDTH&63);
			}
			else
#endif
			for (i=0;i<SCREENWIDTH&63;i++)
			{	dest[3*(64*x+i+SCREENWIDTH*y)]=p_bPalette[3*src[i+((y&63)<<6)]];
				dest[3*(64*x+i+SCREENWIDTH*y)+1]=p_bPalette[3*src[i+((y&63)<<6)]+1];
				dest[3*(64*x+i+SCREENWIDTH*y)+2]=p_bPalette[3*src[i+((y&63)<<6)]+2];
			}
		}
	}
	GL_DumpScreen();
//	free(screen);
}
*/
#endif // ZDOOM_GL
