#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <windows.h>
#include <math.h>
#include <GL/gl.h>
#include <GL/glu.h>
#include "gl_raster.h"

#include "v_video.h"
extern	DCanvas *screen;
#define SCREENWIDTH screen->width

glRaster::glRaster(int height,float red,float green,float blue)
{
	lHeight=height;
	xRed=red; xGreen=green; xBlue=blue;
}

void glRaster::fn_vStartCounter()
{
	QueryPerformanceCounter(&PerformanceCountStart);
}

void glRaster::fn_vStopCounter()
{
	QueryPerformanceFrequency(&PerformanceFrequency);
	QueryPerformanceCounter(&PerformanceCountEnd);
}

void glRaster::fn_vDisplayRaster()
{
	int i;
	static float log2=0.69314718056f;

	#define LENGTH(w,a) (GLfloat) ((w)*(1.0-exp(-(a)*log2)))

	GLfloat t,T,a,w,h,l;
	GLfloat x0=0.0f;
	GLfloat y0=0.0f;

	t=((float) (PerformanceCountEnd.LowPart-PerformanceCountStart.LowPart))/((float) PerformanceFrequency.LowPart);	
	/*if (t)
	{	fps+=1/t;
		lNbFrames++;
	}*/
	T=1.0f/60.0f;
	a=t/T;
	w=(GLfloat)SCREENWIDTH;
	h=(GLfloat)lHeight+10.0f;
	l=LENGTH(w,a); //w*(1.0-exp(-a*log(2.0)));

	// projection
/*	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho( (GLdouble) 0, (GLdouble) SCREENWIDTH, (GLdouble) 0, (GLdouble) SCREENHEIGHT, (GLdouble) -1.0, (GLdouble) 1.0 );
	glMatrixMode(GL_MODELVIEW);
	glPushMatrix();
	glLoadIdentity();
	glTranslatef(x0, y0, 1.0f);*/

	//glColor4f (1.0f, 0.2f, 0.5f, 0.6f);
	glColor4f (xRed, xGreen, xBlue, 0.6f);
	glBegin(GL_QUADS);
	glNormal3f(0.0f,0.0f,1.0f);
	glVertex2f( 0.0f, h);
	glVertex2f( l, h);
	glVertex2f( l, (GLfloat)lHeight);
	glVertex2f( 0.0f, (GLfloat)lHeight);
	glEnd();

	glColor4f (1.0f, 1.0f, 1.0f, 0.7f);
	for (i=0;i<8;i++)
	{
		l=LENGTH(w,(GLfloat) i);
		
		glBegin(GL_QUADS);
		glNormal3f(0.0f,0.0f,1.0f);
		glVertex2f( l-1.0f,(GLfloat)lHeight);
		glVertex2f( l+1.0f,(GLfloat)lHeight);
		glVertex2f( l+1.0f,h+5);
		glVertex2f( l-1.0f,h+5);
		glEnd();
	}

	glPopMatrix();
}
